Option Explicit On 
Option Strict On

Namespace VB21.Day03

    Module modBuiltIn

        Public Sub Main()
            '***Conversions
            'call Conversions module
            Console.WriteLine()
            Console.WriteLine("***Conversion functions***")

            '***Numbers
            Console.WriteLine("***Numbers***")
            Dim iInteger As Integer = 5280
            Dim lLong As Long
            Dim bytByte As Byte
            Dim sngSingle As Single
            Dim dblDouble As Double
            Dim decDecimal As Decimal

            Console.WriteLine("Convert to a Long: {0}", CLng(iInteger) * CLng(iInteger))
            '***Would lead to an exception, as it is too large for a Byte
            'Console.Writeline("Convert to a Byte: {0}", CByte(iInteger))
            Console.WriteLine("Convert to a Single: {0}", CSng(iInteger) / 3.4)
            Console.WriteLine("Convert to a Double: {0}", CDbl(iInteger) / 6.123)
            Console.WriteLine("Convert to a Decimal: {0}", CDec(iInteger) / 34)

            '***Strings
            Console.WriteLine()
            Console.WriteLine("***Strings***")
            Console.WriteLine("Implicit conversion of an integer to a string: {0}", iInteger)
            Console.WriteLine("Explicit conversion of an integer to a string: {0}", CStr(iInteger))

            '***Boolean
            Console.WriteLine()
            Console.WriteLine("***Boolean***")
            Dim iBoolean As Integer = -1
            Dim bBoolean As Boolean = CBool(iBoolean)
            Console.WriteLine("Boolean of {0} is {1}", iBoolean, bBoolean)

            bBoolean = CBool(0)
            Console.WriteLine("Boolean of 0 is {0}", bBoolean)

            '***Dates
            Console.WriteLine()
            Console.WriteLine("***Dates***")
            Dim sDate As String = "8/1/86"
            Dim dtDate As Date = CDate(sDate)
            Console.WriteLine("Date now holds {0}", dtDate)

            sDate = "Tuesday, September 16, 1845 6:45pm"
            dtDate = CDate(sDate)
            Console.WriteLine("Date now holds {0}", dtDate)

            sDate = "15 July, 1215"
            dtDate = CDate(sDate)
            Console.WriteLine("Date now holds {0}", dtDate)

            '***Built-in functions
            Console.WriteLine()
            Console.WriteLine("***Built-in functions***")

            'string handling functions
            Console.WriteLine()
            Console.WriteLine("***String handling functions***")
            Dim sHello As String = "Hello World"
            Console.WriteLine("Original string: {0}", sHello)
            Console.WriteLine("Length of string (Len(sHello)): {0}", Len(sHello))
            Console.WriteLine("Leftmost two characters (Left(sHello, 2)): {0}", Left(sHello, 2))
            Console.WriteLine("Rightmost four characters (Right(sHello, 4)): {0}", Right(sHello, 4))
            Console.WriteLine("From middle of string (Mid(sHello, 4, 5)): {0}", Mid(sHello, 4, 5))
            Console.WriteLine("Starting with character (Mid(sHello, 7)): {0}", Mid(sHello, 7))
            Console.WriteLine("Find character (Instr(1, sHello, 'l')) : {0}", InStr(1, sHello, "l"))
            Console.WriteLine("Find substring (Instr(1, sHello, 'World')) : {0}", InStr(1, sHello, "World"))
            Console.WriteLine("Lowercase (LCase(sHello)) : {0}", LCase(sHello))
            Console.WriteLine("Uppercase (UCase(sHello)) : {0}", UCase(sHello))


            'miscellaneous functions
            Console.WriteLine()
            Console.WriteLine("***Miscellaneous functions***")
            Dim dtNow As Date = Now
            Console.WriteLine("Current date & time: {0}", dtNow)
            dtNow = Today
            Console.WriteLine("Current date: {0}", dtNow)

        End Sub

    End Module

End Namespace
