Imports System.Net
Imports System.IO

Module Module1
    Private Const _
    sConnection As String = _
        "Provider=SQLOLEDB.1;" & _
        "Password=321dweksp302axn;" & _
        "Persist Security Info=True;" & _
        "User ID=sa;" & _
        "Initial Catalog=CD;" & _
        "Data Source=(local)"

    Sub Main()
        Dim sSQL As String
        sSQL = "SELECT ArtistID, ArtistName From Artist"
        Dim objConn _
            As New OleDb.OleDbConnection(sConnection)
        Dim objDataAdapter _
            As New OleDb.OleDbDataAdapter(sSQL, objConn)
        Dim objDS _
            As New DataSet("Artists")
        Dim objDeleteCommand _
            As New OleDb.OleDbCommand()
        Dim objUpdateCommand _
            As New OleDb.OleDbCommand()
        Dim objInsertCommand _
            As New OleDb.OleDbCommand()
        Dim sDeleteSQL As String
        Dim sUpdateSQL As String
        Dim sInsertSQL As String

        sDeleteSQL = "DELETE FROM Artist WHERE ArtistID = ?"

        objDeleteCommand.Connection = objConn
        objDeleteCommand.CommandText = sDeleteSQL

        Dim objParam As OleDb.OleDbParameter
        objParam = objDeleteCommand.Parameters.Add( _
                "@ArtistID", OleDb.OleDbType.Integer)
        objParam.SourceColumn = "ArtistID"
        objParam.SourceVersion = DataRowVersion.Original

        objDataAdapter.DeleteCommand = objDeleteCommand

        sUpdateSQL = "Update Artist SET ArtistName = ? " & _
                     "WHERE ArtistID = ?"

        objUpdateCommand.Connection = objConn
        objUpdateCommand.CommandText = sUpdateSQL

        objParam = objUpdateCommand.Parameters.Add( _
                "@ArtistName", OleDb.OleDbType.Char)
        objParam.SourceColumn = "ArtistName"
        objParam.SourceVersion = DataRowVersion.Current

        objParam = objUpdateCommand.Parameters.Add( _
                "@ArtistID", OleDb.OleDbType.Integer)
        objParam.SourceColumn = "ArtistID"
        objParam.SourceVersion = DataRowVersion.Original

        objDataAdapter.UpdateCommand = objUpdateCommand

        sInsertSQL = "INSERT INTO Artist (ArtistID, ArtistName) " & _
                     "VALUES (?,?)"

        objInsertCommand.Connection = objConn
        objInsertCommand.CommandText = sInsertSQL

        objParam = objInsertCommand.Parameters.Add( _
                "@ArtistID", OleDb.OleDbType.Integer)
        objParam.SourceColumn = "ArtistID"
        objParam.SourceVersion = DataRowVersion.Current

        objParam = objInsertCommand.Parameters.Add( _
                "@ArtistName", OleDb.OleDbType.Char)
        objParam.SourceColumn = "ArtistName"
        objParam.SourceVersion = DataRowVersion.Current

        objDataAdapter.InsertCommand = objInsertCommand

        Try
            objConn.Open()
        Catch myException As System.Exception
            Console.WriteLine(myException.Message)
        End Try

        Try
            Dim sNewArtistSQL As String
            sNewArtistSQL = "INSERT INTO Artist " & _
                "(ArtistID, ArtistName, " & _
                "ArtistFirstName, ArtistLastName)" & _
                "VALUES (11, 'Weird Al Yankovich'," & _
                " 'Al', 'Yankovich')"

            Dim objNewArtistCmd _
                As New OleDb.OleDbCommand(sNewArtistSQL, objConn)
            objNewArtistCmd.ExecuteNonQuery()
        Catch e As Exception
            'Might cause an error because
            'ArtistID #11 already exists
            'But if so, then that is ok.
            Console.WriteLine(e.Message)
        End Try

        If objConn.State = ConnectionState.Open Then
            Try
				objDataAdapter.MissingSchemaAction _
					= MissingSchemaAction.AddWithKey
				objDataAdapter.Fill(objDS, "Artist")

                objConn.Close()
                Dim objTable As DataTable
                objTable = objDS.Tables("Artist")
                Dim drRows As DataRowCollection
                Dim objCurrentRow As DataRow
                drRows = objTable.Rows


				DisplayTable(objTable)

                Console.Write("About to Delete," & _
                    " press return to start!")
                Console.ReadLine()

                'Delete the row with primary key = 11
                drRows.Find(11).Delete()

                Console.Write("After Deletion," & _
                    " press return to view results")
                Console.ReadLine()

                DisplayTable(objTable)

                Console.Write("About to Insert," & _
                    " press return to start!")
                Console.ReadLine()

                Dim drRow As Data.DataRow
                drRow = objTable.NewRow
                drRow("ArtistID") = 40
                drRow("ArtistName") = "Kent Sharkey"
                objTable.Rows.Add(drRow)

				Console.Write("After Insert," & _
					" press return to view!")
                Console.ReadLine()
                DisplayTable(objTable)


				Console.Write("About to Update," & _
					" press return to start!")
                Console.ReadLine()

                'Get Row with Primary Key of 7 (Lisa Loeb)
                drRow = drRows.Find(7)

                drRow.BeginEdit()
                drRow("ArtistName") = "John Doe"
                drRow.EndEdit()

				Console.Write("After Update," & _
					" press return to view results")
                Console.ReadLine()
                DisplayTable(objTable)

                objConn.Open()
                objDataAdapter.Update(objDS, "Artist")

            Catch myException As System.Exception
                Console.WriteLine(myException.Message)
            End Try
			Console.Write("Press Return to End.")
			Console.ReadLine()
        End If
	End Sub
	Sub DisplayTable(ByRef objTable As DataTable)
		Dim objRow As DataRow
		Dim objCol As DataColumn
		Dim i, j As Integer

		For j = 0 To objTable.Columns.Count - 1
			objCol = objTable.Columns(j)
			Console.Write("{0}:{1} ", _
				objCol.ColumnName, _
				objCol.DataType.Name)
		Next
		Console.WriteLine()
		For i = 0 To objTable.Rows.Count - 1
			objRow = objTable.Rows(i)
			Select Case objRow.RowState
				Case DataRowState.Deleted
					Console.Write("[Deleted]   ")
				Case DataRowState.Modified
					Console.Write("[Modified]  ")
                Case DataRowState.Added
                    Console.Write("[New]       ")
                Case DataRowState.Unchanged
                    Console.Write("[Unchanged] ")
            End Select
			For j = 0 To objTable.Columns.Count - 1
				If objRow.RowState <> DataRowState.Deleted Then
					Console.Write("{0} ", _
						objRow.Item(j))
				Else
					Console.Write("{0} ", _
						objRow.Item(j, DataRowVersion.Original))
				End If
			Next
			Console.WriteLine()
		Next
	End Sub
End Module